#include <extdll.h>
#include "sdk_util.h"
#include <dllapi.h>
#include <meta_api.h>
#include "vers_plugin.h"
#include "pm_shared/pm_defs.h"

extern "C" void PM_Move ( struct playermove_s *ppmove, int server );
extern "C" void PM_Init ( struct playermove_s *ppmove  );
extern "C" char PM_FindTextureType( char *name );

void PluginPM_Move(struct playermove_s *ppmove, int server)
{
	PM_Move (ppmove,server);
	RETURN_META(MRES_SUPERCEDE);	//Prevents gamedll's PM_Move to be called
}

void PluginPM_Init(struct playermove_s *ppmove)
{
	PM_Init (ppmove);
	RETURN_META(MRES_SUPERCEDE);	//Prevents gamedll's PM_Move to be called
}


char PluginPM_FindTextureType(char *name)
{
	RETURN_META_VALUE(MRES_SUPERCEDE,PM_FindTextureType(name));
	return 0;//just here to fix Borland C++ error msg (return-inside-macro-not-noticed-bug)
}


static DLL_FUNCTIONS gFunctionTable =
{
	NULL,						//! pfnGameInit()
	NULL,						//! pfnSpawn()
	NULL,						//! pfnThink()
	NULL,						//! pfnUse()
	NULL,						//! pfnTouch()
	NULL,						//! pfnBlocked()
	NULL,						//! pfnKeyValue()
	NULL,						//! pfnSave()
	NULL,						//! pfnRestore()
	NULL,						//! pfnSetAbsBox()

	NULL,						//! pfnSaveWriteFields()
	NULL,						//! pfnSaveReadFields()

	NULL,						//! pfnSaveGlobalState()
	NULL,						//! pfnRestoreGlobalState()
	NULL,						//! pfnResetGlobalState()

	NULL,						//! pfnClientConnect()
	NULL,						//! pfnClientDisconnect()
	NULL,						//! pfnClientKill()
	NULL,						//! pfnClientPutInServer()
	NULL,						//! pfnClientCommand()
	NULL,						//! pfnClientUserInfoChanged()
	NULL,						//! pfnServerActivate()
	NULL,						//! pfnServerDeactivate()

	NULL,						//! pfnPlayerPreThink()
	NULL,						//! pfnPlayerPostThink()

	NULL,						//! pfnStartFrame()
	NULL,						//! pfnParmsNewLevel()
	NULL,						//! pfnParmsChangeLevel()

	NULL,						//! pfnGetGameDescription()
	NULL,						//! pfnPlayerCustomization()

	NULL,						//! pfnSpectatorConnect()
	NULL,						//! pfnSpectatorDisconnect()
	NULL,						//! pfnSpectatorThink()

	NULL,						//! pfnSys_Error()

	PluginPM_Move,					//! pfnPM_Move()
	PluginPM_Init,					//! pfnPM_Init()
	PluginPM_FindTextureType,			//! pfnPM_FindTextureType()

	NULL,						//! pfnSetupVisibility()
	NULL,						//! pfnUpdateClientData()
	NULL,						//! pfnAddToFullPack()
	NULL,						//! pfnCreateBaseline()
	NULL,						//! pfnRegisterEncoders()
	NULL,						//! pfnGetWeaponData()
	NULL,						//! pfnCmdStart()
	NULL,						//! pfnCmdEnd()
	NULL,						//! pfnConnectionlessPacket()
	NULL,						//! pfnGetHullBounds()
	NULL,						//! pfnCreateInstancedBaselines()
	NULL,						//! pfnInconsistentFile()
	NULL,						//! pfnAllowLagCompensation()
};

C_DLLEXPORT int	GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion )
{
	LOG_DEVELOPER(PLID, "called: GetEntityAPI2; version=%d", *interfaceVersion);
	if(!pFunctionTable) {
		LOG_ERROR(PLID,	"GetEntityAPI2 called with null	pFunctionTable");
		return(FALSE);
	}
	else if(*interfaceVersion != INTERFACE_VERSION)	{
		LOG_ERROR(PLID,	"GetEntityAPI2 version mismatch; requested=%d ours=%d",	*interfaceVersion, INTERFACE_VERSION);
		//! Tell engine	what version we	had, so	it can figure out who is out of	date.
		*interfaceVersion = INTERFACE_VERSION;
		return(FALSE);
	}
	memcpy(pFunctionTable, &gFunctionTable,	sizeof(DLL_FUNCTIONS));
	return(TRUE);
}
