#include <extdll.h>
#include <meta_api.h>
#include "sdk_util.h"
#include "vers_plugin.h"

#define COMPILE_TIME __DATE__ ", " __TIME__

// Must provide at least one of these..
META_FUNCTIONS gMetaFunctionTable = {
	NULL,			// pfnGetEntityAPI			HL SDK;		called before game DLL
	NULL,			// pfnGetEntityAPI_Post			META;		called after game DLL
	GetEntityAPI2,		// pfnGetEntityAPI2			HL SDK2;	called before game DLL
	NULL,			// pfnGetEntityAPI2_Post		META;		called after game DLL
	NULL,			// pfnGetNewDLLFunctions		HL SDK2;	called before game DLL
	NULL,			// pfnGetNewDLLFunctions_Post		META;		called after game DLL
	GetEngineFunctions,	// pfnGetEngineFunctions		META;		called before HL engine
	NULL,			// pfnGetEngineFunctions_Post		META;		called after HL engine
};

cvar_t bunnyjump_version	= {"bunnyjump_version",		VVERSION,	FCVAR_EXTDLL | FCVAR_SERVER | FCVAR_UNLOGGED , 0, NULL};
cvar_t bunnyjump_on		= {"bunnyjump_on",		"1",	 FCVAR_EXTDLL, 1, NULL};

extern "C" int use_IN_USE_SLOWDOWN;
extern "C" cvar_t * bunny_active;

// Plugin startup.  Register commands and cvars.
void plugin_init(void) 
{
	LOG_MESSAGE(PLID, REALNAME ", " VDATE);		// "Booster vX.XX, X.XX.XXXX (dd.mm.yy)
	LOG_MESSAGE(PLID, "by "VAUTHOR);		// "by Jussi Kivilinna <me@email.to.me>
	LOG_MESSAGE(PLID, "   "VURL);			// "   http://home.page.dot//
	LOG_MESSAGE(PLID, "compiled: " COMPILE_TIME " EET");
	
	CVAR_REGISTER(&bunnyjump_version);
	CVAR_REGISTER(&bunnyjump_on);
	
	bunny_active = CVAR_GET_POINTER(bunnyjump_on.name);
	
	int pos;
	char mod_name[32];
	char game_dir[256];
	
	// find the directory name of the currently running MOD...
	(*g_engfuncs.pfnGetGameDir)(game_dir);

	pos = strlen(game_dir) - 1;

	// scan backwards till first directory separator...
	while ((pos) && (game_dir[pos] != '/'))
		pos--;

	if (pos == 0) {	return; }

	pos++;
	strcpy(mod_name, &game_dir[pos]);
	
	if(stricmp(mod_name,"gearbox")==0 || stricmp(mod_name,"valve")==0 || stricmp(mod_name,"tfc")==0)
	{
		use_IN_USE_SLOWDOWN=1;
	}
	else
	{
		use_IN_USE_SLOWDOWN=0;
	}
}

